using System;
using System.Collections.Generic;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using SpringPCSCAPI;

namespace SCardTK
{
  public partial class SCardTKForm : Form
  {
    private string SelectedReader = "";
    private NameValueCollection CollectionApdu = new NameValueCollection();
    private char[] delimiterItem = {';'};
    private char[] delimiterCmd = { '=' };
    private char[] delimiterline = { '\n' };
    private char[] delimiterOpt = {',' };
    public string ScriptFileName = "";
    public string format = "asc";
    public string defaultCLA = "FF";
    private byte[] keyAuthDesf;
    private bool AutoConnect = false;


#region forms management
    public SCardTKForm()
    {
      SplashForm MySplashForm = new SplashForm();

      /* Showing configuration form - User has to select reader */
      ConfigReaderForm cf = new ConfigReaderForm(this,true);
      cf.ReadRegister();

      if( (cf.ReaderName == "" ) || (!cf.connect))
        cf.Show();
      else
        SetReader(cf.ReaderName);

     
     // MySplashForm.Show();
      ThStatusDeleg = new ThreadFinishedDelegate(onStatusDone);
     
      InitializeComponent();

      //ReadFile("apdu.cfg");
      if (File.Exists(Application.StartupPath + "\\apdu.cfg"))
        ReadFile(Application.StartupPath + "\\apdu.cfg");

     
    }

  #region menuItems
    private void aboutSCardTKToolStripMenuItem_Click(object sender, EventArgs e)
    {
      // display about form
      AboutForm aboutFrm = new AboutForm();
      aboutFrm.ShowDialog();
    }

    private void setDefaultCLAToolStripMenuItem_Click(object sender, EventArgs e)
    {
      ForceClaForm Fcf = new ForceClaForm(this);
      Fcf.ShowDialog();
    }

    private void chooseAReaderToolStripMenuItem_Click(object sender, EventArgs e)
    {
      // display config reader form
      ConfigReaderForm configFrm = new ConfigReaderForm(this,false);
      configFrm.ShowDialog();
    }
  #endregion

  #region TextBoxes 
    private void InstextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if ((e.KeyCode == Keys.Back) && (InstextBox.Text.Length == 0))
      {
        ClatextBox.Focus();
        if (ClatextBox.Text.Length >1)
        {
          ClatextBox.Text = ClatextBox.Text.Remove(1);
          ClatextBox.SelectionStart = 1;
        }
        return;
      }

      if ((InstextBox.Text.Length == 1) && (e.KeyCode != Keys.Back)
        && (e.KeyCode != Keys.ShiftKey))
      {
        P1textBox.Focus();
        return;
      }
      /*
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if ((e.KeyCode != Keys.Back)
        && (e.KeyCode != Keys.ShiftKey) && (!regHex.IsMatch(e.KeyCode.ToString())))
      {
        //MessageBox.Show(InstextBox.Text.Length.ToString());
       // if (InstextBox.Text.Length > 0)
          InstextBox.Text ="";
        return;
      }*/
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if ((!regHex.IsMatch(InstextBox.Text)))
      {
        InstextBox.Text = "";
      }
    }


    private void P1textBox_KeyDown(object sender, KeyEventArgs e)
    {
      if ((e.KeyCode == Keys.Back) && (P1textBox.Text.Length == 0))
      {
        InstextBox.Focus();
        if (InstextBox.Text.Length > 1)
        {
          InstextBox.Text = InstextBox.Text.Remove(1);
          InstextBox.SelectionStart = 1;
        }
      }
      if ((P1textBox.Text.Length == 1) && (e.KeyCode != Keys.Back)
        && (e.KeyCode != Keys.ShiftKey))
        P2textBox.Focus();
    }

    private void P2textBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && P2textBox.Text.Length == 0)
      {
        P1textBox.Focus();
        if (P1textBox.Text.Length >1)
        {
          P1textBox.Text = P1textBox.Text.Remove(1);
          P1textBox.SelectionStart = 1;
        }
      }

      if ((P2textBox.Text.Length == 1) && (e.KeyCode != Keys.Back)
        && (e.KeyCode != Keys.ShiftKey))
        LctextBox.Focus();
    }



    private void DataintextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && DataintextBox.Text.Length == 0)
      {
        LctextBox.Focus();
        if (LctextBox.Text.Length >1 )
        {
          LctextBox.Text = LctextBox.Text.Remove(1);
          LctextBox.SelectionStart = 1;
        }
      }
    }

    private void LctextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && LctextBox.Text.Length == 0)
      {
        P2textBox.Focus();
        if (P2textBox.Text.Length >1 )
        {
          P2textBox.Text = P2textBox.Text.Remove(1);
          P2textBox.SelectionStart = 1;
        }
      }

      if ((LctextBox.Text.Length == 1) && (e.KeyCode != Keys.Back)
        && (e.KeyCode != Keys.ShiftKey))
        DataintextBox.Focus();
    }

    private void LetextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && LetextBox.Text.Length == 0)
      {
        DataintextBox.Focus();
        if (DataintextBox.Text.Length >1 )
        {
          DataintextBox.Text = DataintextBox.Text.Remove(DataintextBox.Text.Length - 1);
          DataintextBox.SelectionStart = DataintextBox.Text.Length;
        }
      }

      if ((LetextBox.Text.Length == 1) && (e.KeyCode != Keys.Back)
        && (e.KeyCode != Keys.ShiftKey))
        buttonRun.Focus();
    }

    private void ClatextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if ((ClatextBox.Text.Length == 1) && (e.KeyCode != Keys.Back)
        && (e.KeyCode != Keys.ShiftKey))
        InstextBox.Focus();
    }
  #endregion

    public void SetApdu(string rawAPDU)
    {
      clearAll();
     
      string properStr = rawAPDU.Replace(" ", "").Replace("0x", "");
      if (properStr.Length >= 8)
      {
        ClatextBox.Text = properStr.Substring(0, 2);
        InstextBox.Text = properStr.Substring(2, 2);
        P1textBox.Text = properStr.Substring(4, 2);
        P2textBox.Text = properStr.Substring(6, 2);
      }
      if (properStr.Length == 10)
        LetextBox.Text = properStr.Substring(8,2);

      if (properStr.Length > 10)
      {
        // here we have to determine if LE is present or not
        // LC will give us DataIn size
        LctextBox.Text = properStr.Substring(8,2);
        if (properStr.Length > int.Parse(LctextBox.Text)*2 + 10)
        {
          //last byte is LE
          if (properStr.Length - 4 >= 10)
          {
            for (int cpt = 10; cpt < properStr.Length - 2; cpt = cpt+2)
              if(cpt+2< properStr.Length)
                DataintextBox.Text += properStr.Substring(cpt, 2);
          }
          LetextBox.Text = properStr.Substring(properStr.Length-2, 2);
        }
        else
        {
          for (int cpt = 10; cpt < properStr.Length; cpt = cpt+2)
            if (cpt + 2 < properStr.Length)
              DataintextBox.Text += properStr.Substring(cpt, 2);
        }

      }
      RawApduTextBox.Text = rawAPDU;
    }


    private void butClear_Click(object sender, EventArgs e)
    {
      clearAll();
    }

    private void SCardTKForm_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.F5)
        buttonRun_Click(sender, e);
    }

    private void buttonClearHisto_Click(object sender, EventArgs e)
    {
      ResultTextBox.Clear();
      DataOutTextBox.Clear();
    }


    private void clearAll()
    {
      // clear all text boxes 
      ClatextBox.Clear();
      InstextBox.Clear();
      P1textBox.Clear();
      P2textBox.Clear();
      LctextBox.Clear();
      DataintextBox.Clear();
      LetextBox.Clear();
      RawApduTextBox.Clear();
    }

    public void changeCla(string newCla)
    {
      defaultCLA = newCla; 
      // first we change cla in CollectionApdu
      string[] ApduNames = CollectionApdu.AllKeys;
      for (int cpt = 0; cpt < ApduNames.Length; cpt++)
      {
        // looking for first occurence of ';'
        int startIndex = CollectionApdu[ApduNames[cpt]].IndexOf(';');
        int stopIndex = 
          CollectionApdu[ApduNames[cpt]].Remove(startIndex,1).IndexOf(';');
        CollectionApdu[ApduNames[cpt]] =
          CollectionApdu[ApduNames[cpt]].Remove(startIndex + 1, 4).Insert(startIndex + 1, newCla);
        
      }

      // then we change its value in treeView
       //enumNode  = CmdtreeView.Nodes.GetEnumerator;
      foreach (TreeNode config in CmdtreeView.Nodes)
      {
        foreach (TreeNode command in config.Nodes)
        {
          foreach (TreeNode paramater in command.Nodes)
          {
            if (paramater.Text.StartsWith("CLA"))
              paramater.Text = "CLA : " + newCla;
          }
        }
      }
   
    }


#endregion

#region communication functions

    System.Threading.Thread StatusThread = null; /* Get reader status */
    public ThreadFinishedDelegate ThStatusDeleg;
    public delegate void ThreadFinishedDelegate();
    public string StatusStr = "";

    public void ThStatusProc()
    {
      string str = SPCSC.CheckStatus();
      StatusStr = str;
      if (str.Contains(":"))
        StatusStr = StatusStr.Remove(str.IndexOf(':'));
      Invoke(ThStatusDeleg);
    }

    private void timerStatus_Tick(object sender, EventArgs e)
    {
      StatusThread = new System.Threading.Thread(new
      System.Threading.ThreadStart(ThStatusProc));
      StatusThread.Start();
    }

    public void onStatusDone()
    {
      //CardStatustextBox.Text = SPCSC.CheckStatus();
      CardStatusLabel.Text = StatusStr;
      if (CardStatusLabel.Text == "")
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Hide();
        buttonDisco.Hide();
        buttonConnect.Text = "Connect";
      }
      if (CardStatusLabel.Text.Contains("PRESENT"))
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Show();
        buttonDisco.Hide();
        buttonConnect.Text = "Connect";
        if (AutoConnect)
        {
          SPCSC.ConnectCard();
        }
      }
      if (CardStatusLabel.Text.Contains("INUSE"))
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Show();
        pictureBoxP.Hide();
        buttonDisco.Show();
        buttonConnect.Text = "Reconnect";
      }
      if (CardStatusLabel.Text.Contains("EMPTY"))
      {
        pictureBoxAbs.Show();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Hide();
        buttonDisco.Hide();
        buttonConnect.Text = "Connect";
      }
      
    }

    public void SCardTkDisconnect(string mode)
    {
      if (mode == "RESET")
        SPCSC.Disconnect(SPCSC.SCARD_RESET_CARD);
      if (mode == "EJECT")
        SPCSC.Disconnect(SPCSC.SCARD_EJECT_CARD);
      if (mode == "LEAVE")
        SPCSC.Disconnect(SPCSC.SCARD_LEAVE_CARD);
      if (mode == "UNPOWER")
        SPCSC.Disconnect(SPCSC.SCARD_UNPOWER_CARD);
    }

    public void SetReader(string readerName)
    {
      SelectedReader = readerName;
      SPCSC.SetReader(SelectedReader);
      if (SelectedReader == "")
      {
        SelectedReader = "None";
        MessageBox.Show(" Set a reader in menu Configuration - Choose a Reader", "No Reader selected");
      }
      //StatusText.Text = "Selected reader : " + SelectedReader;
    }



    private void buttonRun_Click(object sender, EventArgs e)
    {
      /* we check if text was entered  */
      if (RawApduTextBox.Text == "")
        return;

      if (RawApduTextBox.Text == "Desfire Authenticate")
      {
        Auth_Desfire();
        return;
      }

      
      /* First we test if the text entered is hexadecimal */
      Regex regHex = new Regex("^[0-9a-fA-F]*$");
      if (!regHex.IsMatch(RawApduTextBox.Text))
      {
        ResultTextBox.SelectionColor = Color.Red;
        ResultTextBox.AppendText("Invalid format. Only hexadecimal allowed\n");
        return;
      }

      string properStr = RawApduTextBox.Text;
      /* then we test if length is correct */
      /* we remove every space character, to test if length is even */
      if(RawApduTextBox.Text.Contains(" "))
      {
        properStr = RawApduTextBox.Text.Replace(" ", "");
      }
      if(properStr.Length %2 != 0)
      {
        ResultTextBox.SelectionColor = Color.Red;
        ResultTextBox.AppendText("\nInvalid length.\n");
        return;
      }

      RunApdu(RawApduTextBox.Text);

    }

    private void RunApdu(string RawApdu)
    {
      APDUCmd cmd = new APDUCmd(RawApdu.Replace(" ",""));
      APDURsp answer = new APDURsp();
      
      ResultTextBox.SelectionColor = Color.Black;
      ResultTextBox.AppendText("\nSending : ");
      ResultTextBox.SelectionColor = Color.Blue;
      ResultTextBox.AppendText(cmd.APDUStr);

      if (!SPCSC.Transmit(cmd, ref answer))
      {
        ResultTextBox.SelectionColor = Color.Red;
        ResultTextBox.AppendText("\nError during Transmit, check that card is connected \n");
        ResultTextBox.AppendText("Current card status : " + SPCSC.CheckStatus()+"\n");     
      }
      else
      {
        ResultTextBox.SelectionColor = Color.Black;
        ResultTextBox.AppendText("\nReceived : ");
        ResultTextBox.SelectionColor = Color.Red;
        string answerstr = "";
        if (answer.APDUStr != null)
        {
         // ResultTextBox.AppendText(answer.APDUStr + " - ");
          for (int cpt = 0; cpt < answer.APDUArray.Length; cpt++)
          {
            if (format != "asc")
              answerstr = answerstr + String.Format(format, answer.APDUArray[cpt])
              + " ";
            else
            {
              
              if ((answer.APDUArray[cpt] > 31) && (answer.APDUArray[cpt] < 128))
              {
                answerstr = answerstr +
                    System.Convert.ToChar(answer.APDUArray[cpt]) + " ";
                
              }else
                answerstr = answerstr + String.Format("{0:X02}", answer.APDUArray[cpt])
              + " ";
            }
          }

          ResultTextBox.AppendText(answerstr+" - ");
          ResultTextBox.AppendText(SPCSC.StatusWordsToStr(answer.SW1, answer.SW2));
          DataOutTextBox.Text = answer.DataOutStr;
        }
        else
        { ResultTextBox.AppendText(" Reader Error : Transmit succeeded but no answer received. ");
        }

        ResultTextBox.AppendText("\n");
      }
    }

    private void buttonConnect_Click(object sender, EventArgs e)
    {
      if (buttonConnect.Text == "Reconnect")
      {
        SPCSC.Reconnect();
      }
      else
      {
        // disconnect before connecting
        SPCSC.Disconnect();
        SPCSC.ConnectCard();
        buttonConnect.Text = "Reconnect";
      }
      pictureBoxAbs.Hide();
      pictureBoxAl.Show();
      pictureBoxC.Hide();
      pictureBoxP.Hide();
      buttonDisco.Show();
    }

#endregion

#region config file

    private byte[] createByteArrayFromStr(string StrIn)
    {
      string Str = StrIn.Replace("0x", "").Replace(" ","");
      // command stored into byte array
      byte[] StrBuffer = new byte[Str.Length/2];
      for (int i = 0; i < StrBuffer.Length; i++)
      {
        // converting byte string to byte  
        StrBuffer[i] = System.Convert.ToByte(int.Parse(Str.Substring(i*2,2),
          System.Globalization.NumberStyles.HexNumber));
      }
      return StrBuffer;
    }

    private void openConfigFileToolStripMenuItem_Click(object sender, EventArgs e)
    {
      openConfigDialog.ShowDialog();
    }

    private void ReadConfigFile(object sender, CancelEventArgs e)
    {
      ReadFile(openConfigDialog.FileName);
    }

    private void ReadFile(string filename)
    {
      char[] delimiterLine = { '\n' };

      Stream userFileStream = new FileStream(filename,
        FileMode.Open, FileAccess.Read);
      StreamReader userFileStreamReader = new StreamReader(userFileStream);
      string userFileString = userFileStreamReader.ReadToEnd();


      string[] userFileLines = userFileString.Replace("\r\n\r\n", "\r\n").
        Replace("0x", "").Replace("\r", "").Split(delimiterLine);
      string[] cmdArray;
      string[] ApduArray;
      TreeNode MainNode = new TreeNode();

      for (int cpt = 0; cpt < userFileLines.Length; cpt++)
      {
        if ((userFileLines[cpt].StartsWith("[")) &&
          (userFileLines[cpt].EndsWith("]")))
        {
          // new node 
          MainNode = new TreeNode();
          MainNode.Text =
            userFileLines[cpt].Substring(1, userFileLines[cpt].Length - 2);
          CmdtreeView.Nodes.Add(MainNode);

        }
        else
        {
          cmdArray = userFileLines[cpt].Split(delimiterItem);
          if (cmdArray.Length != 7) // Checking if line syntax is correct
          {
            ApduArray = userFileLines[cpt].Split(delimiterCmd);
            if ((ApduArray.Length>1) && (ApduArray[1].StartsWith("Desfire Authenticate")))
            {
              TreeNode byteNodeAuth = new TreeNode();
              byteNodeAuth.Text = ApduArray[0];
              string[] DesfArray = ApduArray[1].Split(delimiterItem);
              DesfArray[1].Replace("{","").Replace("}","");
              string[] KeyArray = DesfArray[1].Split(delimiterOpt);
              if (KeyArray.Length == 16)
              {
                keyAuthDesf = createByteArrayFromStr(
                  DesfArray[1].Replace(",","").Replace("{","").Replace("}",""));
                MainNode.Nodes.Add(byteNodeAuth);
                byteNodeAuth.Nodes.Add(DesfArray[0].Trim());
              }
            }
            continue;
          }
          TreeNode byteNode = new TreeNode();
          ApduArray = cmdArray[0].Split(delimiterCmd);
          CollectionApdu.Add(ApduArray[0],
            userFileLines[cpt].Replace("=", ";"));
          byteNode.Text = ApduArray[0];
          MainNode.Nodes.Add(byteNode);
          byteNode.Nodes.Add("CLA : " + ApduArray[1].Trim());
          byteNode.Nodes.Add("INS : " + cmdArray[1].Trim());
          byteNode.Nodes.Add("P1 : " + cmdArray[2].Trim());
          byteNode.Nodes.Add("P2 : " + cmdArray[3].Trim());
          byteNode.Nodes.Add("LC : " + cmdArray[4].Trim());
          byteNode.Nodes.Add("DataIn : " + cmdArray[5].Trim());
          byteNode.Nodes.Add("LE : " + cmdArray[6].Trim());
        }
      }


      userFileStreamReader.Close();
      userFileStream.Close();
    }
#endregion

# region TreeView
    private void CmdtreeView_MouseDoubleClick(object sender, MouseEventArgs e)
    {
      if (CmdtreeView.SelectedNode.Text == "DESFIRE AUTHENTICATE")
      {
        RawApduTextBox.Text = "Desfire Authenticate";
        Auth_Desfire();
      }
      else
      {
        /*  Display ApduParameter Dialog to configure APDU  */
        if (CmdtreeView.SelectedNode.Level == 1)
        {
          ApduParametersForm Apf =
            new ApduParametersForm(CollectionApdu[CmdtreeView.SelectedNode.Text], this);
          Apf.ShowDialog();
        }
      }
    }

    private void CmdtreeView_MouseClick(object sender, MouseEventArgs e)
    {
      if (CmdtreeView.SelectedNode.Text == "DESFIRE AUTHENTICATE")
      {
        clearAll();
        RawApduTextBox.Text = "Desfire Authenticate";
      }
      else
      {
        if (CmdtreeView.SelectedNode != null)
        {
          /* Display in Apdu Panel's textBoxes the Apdu  */
          if (CmdtreeView.SelectedNode.Level == 1)
          {
            clearAll();
            string[] ApduSelected =
                CollectionApdu[CmdtreeView.SelectedNode.Text].Split(delimiterItem);

            if (!ApduSelected[1].StartsWith("{") && !ApduSelected[1].StartsWith("X") &&
              !ApduSelected[1].StartsWith("-"))
            {
              ClatextBox.Text = ApduSelected[1];
            }
            else
              ClatextBox.Text = "";

            if (!ApduSelected[2].StartsWith("{") && !ApduSelected[2].StartsWith("X") &&
              !ApduSelected[2].StartsWith("-"))
            {
              InstextBox.Text = ApduSelected[2];
            }
            else
              InstextBox.Text = "";

            if (!ApduSelected[3].StartsWith("{") && !ApduSelected[3].StartsWith("X") &&
              !ApduSelected[3].StartsWith("-"))
            {
              P1textBox.Text = ApduSelected[3];
            }
            else
              P1textBox.Text = "";

            if (!ApduSelected[4].StartsWith("{") && !ApduSelected[4].StartsWith("X") &&
              !ApduSelected[4].StartsWith("-"))
            {
              P2textBox.Text = ApduSelected[4];
            }
            else
              P2textBox.Text = "";

            if (!ApduSelected[5].StartsWith("{") && !ApduSelected[5].StartsWith("X") &&
              !ApduSelected[5].StartsWith("-"))
            {
              LctextBox.Text = ApduSelected[5];
            }
            else
              LctextBox.Text = "";

            if (!ApduSelected[6].StartsWith("{") && !ApduSelected[6].StartsWith("X") &&
              !ApduSelected[6].StartsWith("-"))
            {
              DataintextBox.Text = ApduSelected[6];
            }
            else
              DataintextBox.Text = "";

            if (!ApduSelected[7].StartsWith("{") && !ApduSelected[7].StartsWith("X") &&
              !ApduSelected[7].StartsWith("-"))
            {
              LetextBox.Text = ApduSelected[7];
            }
            else
              LetextBox.Text = "";

          }
        }
      }
    }
#endregion

# region Update text boxes
    private void UpdateRawApduText() 
    {
      RawApduTextBox.Text = ClatextBox.Text + InstextBox.Text + P1textBox.Text +
        P2textBox.Text + LctextBox.Text + DataintextBox.Text + LetextBox.Text;
    }

    private void ClatextBox_TextChanged(object sender, EventArgs e)
    {
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if (ClatextBox.Text.Length > 0)
      {
        if ((!regHex.IsMatch(ClatextBox.Text)))
        {
          ClatextBox.Text = ClatextBox.Text.Remove(ClatextBox.Text.Length - 1);
          ClatextBox.Focus();
          ClatextBox.SelectionStart = ClatextBox.Text.Length;
          return;
        }
      }
      UpdateRawApduText();
    }

    private void InstextBox_TextChanged(object sender, EventArgs e)
    {
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if (InstextBox.Text.Length > 0)
      {
        if ((!regHex.IsMatch(InstextBox.Text)))
        {
          InstextBox.Text = InstextBox.Text.Remove(InstextBox.Text.Length - 1);
          InstextBox.Focus();
          InstextBox.SelectionStart = InstextBox.Text.Length;
          return;
        }
      }
      
      UpdateRawApduText();
    }

    private void P1textBox_TextChanged(object sender, EventArgs e)
    {
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if (P1textBox.Text.Length > 0)
      {
        if ((!regHex.IsMatch(P1textBox.Text)))
        {
          P1textBox.Text = P1textBox.Text.Remove(P1textBox.Text.Length - 1);
          P1textBox.Focus();
          P1textBox.SelectionStart = P1textBox.Text.Length;
          return;
        }
      }
      UpdateRawApduText();
    }

    private void P2textBox_TextChanged(object sender, EventArgs e)
    {
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if (P2textBox.Text.Length > 0)
      {
        if ((!regHex.IsMatch(P2textBox.Text)))
        {
          P2textBox.Text = P2textBox.Text.Remove(P2textBox.Text.Length - 1);
          P2textBox.Focus();
          P2textBox.SelectionStart = P2textBox.Text.Length;
          return;
        }
      }
      UpdateRawApduText();
    }

    private void LctextBox_TextChanged(object sender, EventArgs e)
    {
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if (LctextBox.Text.Length > 0)
      {
        if ((!regHex.IsMatch(LctextBox.Text)))
        {
          LctextBox.Text = LctextBox.Text.Remove(LctextBox.Text.Length - 1);
          LctextBox.Focus();
          LctextBox.SelectionStart = LctextBox.Text.Length;
          return;
        }
      }
      UpdateRawApduText();
    }

    private void DataintextBox_TextChanged(object sender, EventArgs e)
    {
      Regex regHex = new Regex("^[0-9a-fA-F]*$");
      if (DataintextBox.Text.Length > 0)
      {
        if ((!regHex.IsMatch(DataintextBox.Text)))
        {
          DataintextBox.Text = DataintextBox.Text.Remove(DataintextBox.Text.Length - 1);
          DataintextBox.Focus();
          DataintextBox.SelectionStart = DataintextBox.Text.Length;
          return;
        }
      }
      UpdateRawApduText();
    }

    private void LetextBox_TextChanged(object sender, EventArgs e)
    {
      Regex regHex = new Regex("^[0-9a-fA-F]{1,2}$");
      if (LetextBox.Text.Length > 0)
      {
        if ((!regHex.IsMatch(LetextBox.Text)))
        {
          LetextBox.Text = LetextBox.Text.Remove(LetextBox.Text.Length - 1);
          LetextBox.Focus();
          LetextBox.SelectionStart = LetextBox.Text.Length;
          return;
        }
      }
      UpdateRawApduText();
    }

#endregion

#region resizing

    private void splitContainer2_Panel1_Resize(object sender, EventArgs e)
    {
      RawApduTextBox.Width = splitContainer2.Panel1.Width - 43;
      LetextBox.Location = new System.Drawing.Point(splitContainer2.Panel1.Width - 61, 
        24);
      labelLe.Location = new Point(splitContainer2.Panel1.Width - 66, 8);
      DataintextBox.Width = splitContainer2.Panel1.Width - 222;
      butClear.Location = new Point(splitContainer2.Panel1.Width - 91, 
        100);
      buttonRun.Location = new Point(splitContainer2.Panel1.Width / 2 - 65, 99);
    }


    private void splitContainer4_Panel2_Resize(object sender, EventArgs e)
    {
      buttonClearHisto.Location = new System.Drawing.Point(splitContainer4.Panel2.Width - 110, 3);
      DataOutTextBox.Width = splitContainer4.Panel2.Width - 245;
    }

    private void saveToolStripMenuItem_Click(object sender, EventArgs e)
    {
      string Script = ResultTextBox.Text; 
      // is there anything to save?
      if (Script != "")
      {
        if (ScriptFileName == "")
        {//no default file
          saveFileDialog.ShowDialog();
        }
        else
        {// writing on default file 
          writeFile();
        }
      }
    }
#endregion

#region file management

    private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
    {
      ScriptFileName = saveFileDialog.FileName;
      writeFile();
    }

    public void writeFile()
    {
      // getting user entry
      string Script = ResultTextBox.Text;
      string[] lines = Script.Split(delimiterline);

      Stream writeFileStream = new FileStream(ScriptFileName,
        FileMode.OpenOrCreate, FileAccess.Write);
      StreamWriter writeFileStreamWriter = new StreamWriter(writeFileStream);

      foreach (string line in lines)
      {
        
        if (line.StartsWith("Sending :"))
        {
          writeFileStreamWriter.WriteLine(line.Replace("Sending : ", "\r\n#Sending : \r\n"));
          
        }
        else
        {
          if (line.Trim().Length != 0)
            writeFileStreamWriter.WriteLine(line.Insert(0, "#"));
        }
      }

      writeFileStreamWriter.Close();
      writeFileStream.Close();

    }

    private void runALoggedSessionToolStripMenuItem_Click(object sender, EventArgs e)
    {
      openLogFileDialog.ShowDialog();
    }

    private void openLogFileDialog_FileOk(object sender, CancelEventArgs e)
    {
      Stream userFileStream = new FileStream(openLogFileDialog.FileName,
        FileMode.Open, FileAccess.Read);
      StreamReader userFileStreamReader = new StreamReader(userFileStream);
      string userFileString = userFileStreamReader.ReadToEnd();
      userFileStreamReader.Close();
      userFileStream.Close();

      string[] lines = userFileString.Split(delimiterline);
      foreach (string line in lines)
      {
        if (line.Trim() == "")
          continue;
        // skip comment
        if (line.Trim().StartsWith("#"))
          continue;
        Regex regHex = new Regex("^[0-9a-fA-f ]*$");
        if (!regHex.IsMatch(line.Trim()))
        {
          
          continue;
        }
        RunApdu(line.Trim());
      }
     
    }


#endregion


    private void testAllCLAToolStripMenuItem_Click(object sender, EventArgs e)
    {
      for (byte b = 0x00; b <= 0xFE; b++)
        RunApdu(defaultCLA + String.Format("{0:X02}",b)+ "000000");
    }

    private void buttonDisco_Click(object sender, EventArgs e)
    {
      // prompting for disconnect mode : EJETC, RESET, LEAVE or UNPOWER
      DiscoForm Dfrm = new DiscoForm(this);
      Dfrm.ShowDialog();
    }

#region desfire authenticate
    [DllImport("pcsc_desfire.dll", EntryPoint = "SCardDesfire_Authenticate",
      CallingConvention = CallingConvention.Cdecl)]
    public static extern int pcscAuth(int hCard, byte KeyNb, byte[] Key);

    public byte[] DESFIRE_KEY_1 =
      new byte[16] { 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
      0x00, 0x00, 0x00, 0x00, 0x11, 0x22, 0x33
    };

    private void Auth_Desfire()
    {
      if (keyAuthDesf == null)
      {
        
        ResultTextBox.SelectionColor = Color.Red;
        ResultTextBox.AppendText("\nNo Desfire key provided. Cannot Authenticate");
        return;
      }
      
      ResultTextBox.SelectionColor = Color.Black;
      ResultTextBox.AppendText("\nSending : ");
      ResultTextBox.SelectionColor = Color.Blue;
      ResultTextBox.AppendText("Desfire Authenticate");
      ResultTextBox.SelectionColor = Color.Black;
      ResultTextBox.AppendText("\nReceived : ");
      ResultTextBox.SelectionColor = Color.Red;
      if (pcscAuth(SPCSC.GetHCard(), 1, keyAuthDesf) != SPCSC.SPCSC_SUCCESS)
        ResultTextBox.AppendText("Desfire authenticate failed");
      else
        ResultTextBox.AppendText("Desfire authenticate succeeded");

      ResultTextBox.AppendText("\n");
    }
#endregion

#region format

    private void checkBoxAsc_CheckedChanged(object sender, EventArgs e)
    {
      if (checkBoxAsc.Checked)
        format = "asc";
      else
        format = "{0:X02}";
    }

    private void checkBoxAutoC_CheckedChanged(object sender, EventArgs e)
    {
      AutoConnect = checkBoxAutoC.Checked;
    }
#endregion

    private void ResultTextBox_TextChanged(object sender, EventArgs e)
    {
      // scroll bar
      // Put the cursor at the very end of the text
      ResultTextBox.Select((ResultTextBox.Text.Length), 0);

      // Scroll
      ResultTextBox.ScrollToCaret();
    }









  }
}